package org.jivesoftware.openfire.plugin;

import org.jivesoftware.openfire.container.Plugin;
import org.jivesoftware.util.Log;
import java.io.File;
import java.io.FileReader;
import java.io.BufferedReader;
import java.lang.StringBuffer;
import java.io.IOException;
import java.io.FileNotFoundException;
/*
 * This class is used to read html files! Out of the classes folder!
 * This is used because we can get no access to jsp files within the
 * web folder which are not registrated with the adminconsole.
 * This enables the possibility to devide the code from the design part.
 */
public class HTMLOutput {

	// This function will open the default error page error.html
	// and replaces the tokens %TITLE% and %MESSAGE%.
	public static String getErrorMessage(File pluginDirectory ,String errTitle,String errMsg){
		File resDirectory = new File(pluginDirectory, "classes");
		if(resDirectory.exists()){
			try{
				String s = getFileAsString(resDirectory,"error.html");
					s = s.replaceAll("%TITLE%", errTitle);
					s = s.replaceAll("%MESSAGE%", errMsg);
					return s;
			}catch(FileNotFoundException fne){
				Log.warn("The file error.html does not exist in the classes directory!");
				return defError("error.html");
			}catch(IOException ioEx){
				Log.warn("Can't open the file error.html, may be the file is locked!");
				return defError("error.html");
			}
		}
		Log.warn("The classes directory does not exist!" + resDirectory.getPath());
		return defError("error.html");
	}
	// this function opens the given file and returns the file contents as a string!
	public static String getHTMLFile(File pluginDirectory, String fileName){
		File resDirectory = new File(pluginDirectory, "classes");
		if(resDirectory.exists()){
			try{
				return getFileAsString(resDirectory, fileName);
			}catch(FileNotFoundException fne){
				Log.warn("The file "+ fileName +" does not exist in the classes directory!");
				return defError( fileName );
			}catch(IOException ioEx){
				Log.warn("Can't open the file " + fileName + ", may be the file is locked!");
				return defError( fileName );
			}
		}
		Log.warn("The classes directory does not exist!");
		return defError( fileName );
	}
	
	private static String defError(String filename){
		return "The file: " + filename + " could not be found!";
	}
	
	public static String getFileAsString(File lDirectory,String lFileName) throws IOException,FileNotFoundException{
		FileReader errFile = new FileReader(new File(lDirectory,lFileName));
		BufferedReader bufRead = new BufferedReader(errFile);
		StringBuffer bufOut = new StringBuffer();
		String s;
		while( (s = bufRead.readLine()) != null ){
			bufOut.append(s);
		}
		s = bufOut.toString();
		bufRead.close();
		errFile.close();
		return s.toString();
	}

}
