<%@ page import="java.util.*,
                 org.jivesoftware.admin.*,
                 org.jivesoftware.openfire.XMPPServer,
                 org.jivesoftware.util.*,
                 org.jivesoftware.openfire.plugin.PassServicePlugin"
    errorPage="error.jsp"
%>

<%@ taglib uri="http://java.sun.com/jstl/core_rt" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jstl/fmt_rt" prefix="fmt" %>

<%-- Define Administration Bean --%>
<jsp:useBean id="admin" class="org.jivesoftware.util.WebManager"  />
<c:set var="admin" value="${admin.manager}" />
<% admin.init(request, response, session, application, out ); %>

<%  // Get parameters
    boolean save = request.getParameter("save") != null;
    boolean success = request.getParameter("success") != null;
    boolean enabled = ParamUtils.getBooleanParameter(request, "enabled");
    String  sourceEmail = ParamUtils.getParameter(request, "sourceEmail", true);
    String hostname		= ParamUtils.getParameter(request, "hostname", true);
    int		lifetime	= ParamUtils.getIntParameter(request, "lifetime",1);
    boolean useSSL		= ParamUtils.getBooleanParameter(request, "useSSL");
    boolean emailConfigured = false;

    PassServicePlugin plugin = (PassServicePlugin) XMPPServer.getInstance().getPluginManager().getPlugin("passservice");

    // Handle a save
    Map errors = new HashMap();
    if (save) {
        if (errors.size() == 0) {
				plugin.setEnabled(enabled);
				plugin.setSourceEmail(sourceEmail);
				plugin.setLifetime(lifetime);
				plugin.setSSL(useSSL);
				plugin.setHostname(hostname);
            response.sendRedirect("pass-service.jsp?success=true");
            return;
        }
    }

    enabled		= plugin.isEnabled();
    sourceEmail	= plugin.getSourceEmail();
    lifetime	= plugin.getLifetime();
    useSSL		= plugin.isSSL();
    emailConfigured = plugin.isEmailConfigured();
    hostname	= plugin.getHostname();
%>

<html>
    <head>
        <title>Pass Service Properties</title>
        <meta name="pageID" content="pass-service"/>
    </head>
    <body>


<p>
Use the form below to enable or disable the Pass Service.
By default the Pass Service plugin is <strong>disabled</strong>, which means that
HTTP requests to the service will be ignored.
</p>

<%  if (success) { %>

    <div class="jive-success">
    <table cellpadding="0" cellspacing="0" border="0">
    <tbody>
        <tr><td class="jive-icon"><img src="images/success-16x16.gif" width="16" height="16" border="0"></td>
        <td class="jive-icon-label">
            Pass service properties edited successfully.
        </td></tr>
    </tbody>
    </table>
    </div><br>
<% } %>

<%	if (!emailConfigured) { %>
	<div class="jive-error">
    <table border="0" cellpadding="0" cellspacing="0">
    <tbody>
        <tr><td class="jive-icon"><img src="images/error-16x16.gif" border="0" height="16" width="16"></td>
        <td class="jive-icon-label">
            The email service haven't been configured!
        </td></tr>
    </tbody>
    </table>
    </div><br>
	
<% } %>
<form action="pass-service.jsp?save" method="post">

<fieldset>
    <legend>Pass Service</legend>
    <div>
    <p>
    Normally it is not possible to reset the own password if it has been forgotten.
    This service makes it possible to reset the password while generating a token
	and authentificates the user with the username and the token which will be send to the users email address.
	</p>

    <p>However, the presence of this service exposes a security risk. Therefore the token together with the username is used for
	the authentification process.
    </p>
    <ul>
        <input type="radio" name="enabled" value="true" id="rb01"
        <%= ((enabled) ? "checked" : "") %>>
        <label for="rb01"><b>Enabled</b> - Pass service requests will be processed.</label>
        <br>
        <input type="radio" name="enabled" value="false" id="rb02"
         <%= ((!enabled) ? "checked" : "") %>>
        <label for="rb02"><b>Disabled</b> -Pass service requests will be ignored.</label>
        <br><br>
    </ul>
        <p>
       	Leave the Source Email Address field blank to use the email address of the administrator per default! 
        </p>
        <ul>
        <label for="sourceEmail">Source Email Address:</label>
        <input type="text" name="sourceEmail" value="<%= sourceEmail %>" id="sourceEmail" size="25">
        </ul>
        <p>
       	Leave the Hostname field blank to use the default hostname, detected by openfire.
        </p>
        <ul>
        <label for="hostname">Hostname to use within the email:</label>
        <input type="text" name="hostname" value="<%= hostname %>" id="hostname" size="25">
        </ul>
        <p>
        Specify the lifetime for the generated token in days!
        </p>
        <ul>
        <label for="lifetime">Lifetime:</label>
        <input type="text" name="lifetime" value="<%=  lifetime %>" id="lifetime">
        </ul>
        <p>
        Should we use a SSL connection when the users using the link in the email they've got!<BR>
        This will only effect the link in the email not the server!
        </p>
        <ul>
        <input type="radio" name="useSSL" value="true" id="rb03"
        <%= ((useSSL) ? "checked" : "") %>>
        <label for="rb03"><b>Enabled</b> - The link in the email will use SSL!</label>
        <br>
        <input type="radio" name="useSSL" value="false" id="rb04"
         <%= ((!useSSL) ? "checked" : "") %>>
        <label for="rb04"><b>Disabled</b> - The link in the email won't use SSL! </label>
        </ul>
    </ul>
    </div>
</fieldset>

<br><br>

<input type="submit" value="Save Settings">
</form>


</body>
</html>